#!/nfs-home/mjones/usr/bin/ruby -w

def album_to_xml(album)
  text = IO.readlines(album).join('').strip

  # substitutions
  text.gsub!('sampleimage', 'thumbnail')
  protect_cdata(text)

  # wrap in XML crap
  text = <<"EOF"
<?xml version="1.0" ?>
<config>
#{text}
</config>
EOF

  return text
end

def protect_cdata(text)
  text.gsub!(%r!<((?:short|long)desc)>(.*?)</\1>!m) do |match|
    element, content = $1, $2.strip
    if content =~ /[;<>]/
      <<EOF
<#{element}>
    <![CDATA[
#{content}
    ]]>
</#{element}>
EOF
    else
      match
    end
  end
end

$stdin.readlines.each do |album|
  album.chomp!
  raise "huh" unless album =~ %r!(.*)/(.*)!

  path, file = $1
  newfile = path + "/album.xml"

  printf album + " ... "

  xml = File.new(newfile, 'w')
  xml.puts album_to_xml(album)

  puts "done"
end

